﻿/*!
 * list.js
 * CSS 基于  minimobile.css
 */
(function () {
	//构造器
	function RichEditor(config) {
	       this.editor;
	       this.showEditor;
	       this.placeholderText;
		this.voiceImage = ['img/1.png', 'img/2.png', 'img/3.png', 'img/4.png'];
		this.myAudio;
		this.audioId;
		this.isAutoPlayVoice;
		this.voiceTimeout;
		this.IsCallBackUrl=false;
		this.isShowHtml=false;
		this.showId;
		this.id;
		this.ImageType='0';
		this.VoiceType='1';
		this.VideoType='2';
		this.AtType='3';
		this.placeholdeDiv;
		this.initHtml;
		this.initShowHtml;
		this.IsmoveImage=false;
		this.IsinsertImage=false;
		this.init(config);
		return this;
	}
	RichEditor.prototype = {
		constructor: RichEditor,
		init: function(config){
			 var _this = this

           	      //回调数据方式
         		_this.IsCallBackUrl = config.IsCallBackUrl ? config.IsCallBackUrl : false
           	      //回调数据
           	      _this.reCallback = config.reCallback ? config.reCallback : function (html) {}
           	       //回调状态
  			_this.reState = config.reState ? config.reState : function (items) {}
  			 //回调点击图片事件
			_this.reOnclickImage = config.reOnclickImage ? config.reOnclickImage : function (url) {	console.log(url)}
  			//回调点击音频事件
  			_this.reOnclickVoice = config.reOnclickVoice ? config.reOnclickVoice : function (url) {}
  			//回调点击at事件
  			_this.reOnclickAt = config.reOnclickAt ? config.reOnclickAt : function (name, id) {}
  			//回调点击视频事件
  			_this.reOnclickVideo = config.reOnclickVideo ? config.reOnclickVideo : function (url) {}
  			//回调editor初始化事件
                   _this.reEditorReady = config.reEditorReady ? config.reEditorReady : function (REditor) {}
  			//是否自动播放音频
  			_this.isAutoPlayVoice= config.isAutoPlayVoice ? config.isAutoPlayVoice : false

  			_this.initHtml= config.initHtml ? config.initHtml : ''

  			_this.initShowHtml= config.initShowHtml ? config.initShowHtml : ''
  			_this.myAudio = new Audio()
  		       _this.myAudio.addEventListener('ended', function () {
    				_this.stopVoiceImg(_this.audioId)
     			audioId = ''
   				 // 在这个方法里写相应的逻辑就可以了
  			}, false)

  			 //是否展示HTML
         		_this.isShowHtml = config.isShowHtml ? config.isShowHtml : false
         		if(_this.isShowHtml)
         		{
         		       if(_this.isEmpty(config.showId))
         		       console.error('显示HTML需要配置正确的ShowID');
         		       _this.showEditor=document.getElementById(config.showId);
         		       _this.reEditorReady(_this)
         		       return;
         		}
         		if(_this.isEmpty(config.id))
         		{
         		 console.error('编辑HTML需要配置正确的ID');
         		 return
         		}

			_this.id= config.id ? config.id : ''
			UE.delEditor(config.id)
  			_this.editor=UE.getEditor(config.id,{
        		//这里可以选择自己需要的工具按钮名称,此处仅选择如下五个
            	toolbars:[],
            	//focus时自动清空初始化时的内容
           	 	autoClearinitialContent:true,
           	       //关闭字数统计
            	wordCount:false,
           		//关闭elementPath
            	elementPathEnabled:false,
            	//默认的编辑区域高度
            	initialFrameHeight:400,
            	imageScaleEnabled:false
            	//更多其他参数，请参考ueditor.config.js中的配置项
           	      });
           	      _this.placeholderText= config.placeholderText ? config.placeholderText : '请输入文字'
          		//_this.editor.placeholder(_this.placeholderText);
          	       //editor加载完成事件
  			_this.editor.addListener( 'ready', function( editor ) {
     			 _this.addPlaceholder(_this.placeholderText)
     			 //_this.editor.execCommand( 'focus' ); //编辑器家在完成后，让编辑器拿到焦点

     			 _this.reEditorReady(_this)

 			} );
 			 //内容变更事件
  			_this.editor.addListener('contentChange', function () {
  				_this.callback()
  				if(_this.IsinsertImage)
  				_this.addImageClickListener();
  				}
  			)
  			_this.editor.addListener("focus", function () {
                    _this.placeholdeDiv.style.display="none";
				});
			_this.editor.addListener("blur", function () {
				var localHtml = _this.editor.getContent()
				if (_this.isEmpty(localHtml)) {
                    _this.placeholdeDiv.style.display="block";
				}

			});


				 //键盘抬起事件
  			_this.editor.addListener('keyup', function (type,e) {
   			 var KEY_LEFT = 37, KEY_RIGHT = 39, KEY_DELETE = 8, KEY_ENTER = 13
    			 if (e.which == KEY_LEFT || e.which == KEY_RIGHT || e.which == KEY_DELETE ||
     		 e.which == KEY_ENTER) {
                    _this.enabledEditingItems(_this.getHtml())
   			 }

  			})
  			//为所有的自定义父级span 添加禁止编辑
  		      _this.editor.addInputRule(function(root){
  		       /*此段处理复制粘贴事件	*/

      		var imgs=root.getNodesByTagName('img');
      			console.log(imgs)
      		 if(_this.isEmpty(imgs)) _this.IsinsertImage=false; else _this.IsinsertImage=true;
     		  for (var img of imgs)
      		{
      	  	  	if(!img.parentNode||!img.parentNode.attrs.class||img.parentNode.attrs.class.indexOf('div_data')<0)
      	  	  		{
      	  	  			var node = new  UE.uNode({
    						 	type:'element',
    					 		tagName:'span'
 				      	});
 				      	var	html = '<img src="' + img.attrs.src + '" alt=""/>'
 				      	node.innerHTML(html);
 				      	node.attrs.class='div_data div_image';
 				      	node.attrs.data_value=img.attrs.src;
 				      	node.attrs.data_type='0';
 				      	node.attrs.data_remark='';
 				      	img.parentNode.replaceChild(node,img);

      	  	  		}
      		}
      		/*此段处理自定义插入事件	*/
      		var tags=root.getNodesByTagName('span');
     		for(var tag of tags)
     		{

      			if(tag.attrs.class&&tag.attrs.class.indexOf('div_data')>=0&&tag.attrs.data_type!=_this.ImageType)
      			tag.attrs.contenteditable='false'
    			}
 			});

  		   	 //点击事件回调格式
  		   	_this.editor.addListener('click', function () {_this.enabledEditingItems('')})


			console.log('RichEditor初始化！！！！')
            },
            callback: function()
			{
			 var _this=this;
			 this.reCallback(this.getHtml())
			 if(this.IsCallBackUrl)
 			 window.location.href = "re-callback://" + encodeURI(this.getHtml());
			},
			clearHtml: function ()
			{
				if(this.isEmpty(this.editor))
				return
				this.editor.focus()
				this.editor.execCommand('cleardoc');
				this.editor.execCommand('inserthtml','<p></p>');
			//this.editor.execCommand('cleardoc');
			},
        	setHtml : function (html) {
        		//RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'))
				this.editor.focus()
				this.editor.body.innerHTML='';
        		var datahtml=this.setDataHtml(html)
        		this.editor.execCommand('inserthtml',datahtml);
        		this.addPlayVoiceListener()

        	},
        	showHtml :  function (html) {

  				var datahtml=this.setDataHtml(html)
  				this.showEditor.innerHTML=datahtml
  				this.addShowClickListener()
		},
		getHtml : function () {
	             if(this.isEmpty(this.editor.getContentTxt()))
		 	        return '';
  			  return this.getDataHtml(this.editor.body.innerHTML)
		},
		getECHtml : function () {

          			  return encodeURI(this.getHtml())
        },
	  	focus: function(){
	  		this.editor.focus(true)
	  	},
	       insertImage :function (url, alt) {

  			this.editor.execCommand('inserthtml',this.parseSetDataHtml(this.ImageType,url,alt,'',''));
		},
		insertVoice :function (url, alt) {
  			this.editor.execCommand('inserthtml',this.parseSetDataHtml(this.VoiceType,url,alt,'',''));
  			this.addPlayVoiceListener();
		},
		insertAt :function (id, name) {
  			this.editor.execCommand('inserthtml',this.parseSetDataHtml(this.AtType,id,name,'',''));
		},
		insertVideo :function (url, alt) {
  			this.editor.execCommand('inserthtml',this.parseSetDataHtml(this.VideoType,url,alt,'',''));
		},
		insertLink:function (url, title){
			this.editor.execCommand( 'link', '{url:'+url+',title:'+title+'}' );
		},
		setDataHtml:function(html){
	       	    var reg =  /(<span class=\"div_data.*?>|<div class=\"div_data.*?>)(<\/)(.*?>)/g;//
			console.log(html);
   			    var matchs=html.match(reg);
			console.log(matchs);
   			    if(this.isEmpty(matchs)) return html;
   			    for (var match of matchs)
   			    {
   	 			 //var typereg='data_type="';
	  			 //var valuereg='data_value="';
	  			 //var remarkreg='data_remark="';
	   		        //var typezw=match.indexOf(typereg)+typereg.length;
	   			 //var valuezw=match.indexOf(valuereg)+valuereg.length;
	   		 	 //var remarkzw=match.indexOf(remarkreg)+remarkreg.length;
	   			 var type=this.getMatchData('data_type="',match);
	   			 var value=this.getMatchData('data_value="',match);
	   			 var remark=this.getMatchData('data_remark="',match);
	   			 var w=this.getMatchData('data_w="',match);
	   			 var h=this.getMatchData('data_h="',match);
	   			 console.log(type);
	  		       //var value=match.substring(valuezw, match.indexOf('"',valuezw));
	   		 	 //var remark=match.substring(remarkzw, match.indexOf('"',remarkzw));
	   		 	 var datahtml='';
	   		 	// if(_this.isShowHtml)
	   		       datahtml = this.parseSetDataHtml(type, value, remark,w,h)
	   			 //else
	   			 //datahtml = this.parseShowDataHtml(type, value, remark)
	   			 if(!this.isEmpty(datahtml))
	   			 html=html.replace(match, datahtml)
  			  }
  			   console.log(html);
  			  return html
	   	 },
	   	 getDataHtml:function(editorhtml)
	       {
  			  	  var parents = this.editor.document.getElementsByClassName('div_data')
				  for (var object of parents) {
    					var data_type = object.getAttribute('data_type')
    					if (this.isEmpty(data_type)) continue
    					var data_value = object.getAttribute('data_value')
    					var data_remark = object.getAttribute('data_remark')
    					var html = '<span class="' + object.className + '" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark;
    					var img=object.getElementsByTagName('img');
    					if(img.length>0)
    					{
    					html=html+'" data_w="' + img[0].style.width;
    					html=html+'" data_h="' + img[0].style.height;
    			      	}
    					html=html+'"></span>';
		  			editorhtml = editorhtml.replace(object.outerHTML, html)

 				 }
 				 return editorhtml
	   	  },
	   	  getMatchData:function(reg,match)
	   	  {
	  		  if(match.indexOf(reg)<0) return '';
	   		  var regzw=match.indexOf(reg)+reg.length;
	   		  var regstr=match.substring(regzw, match.indexOf('"',regzw));
	   		  return regstr;
	   	  },
               parseSetDataHtml : function (data_type,data_value,data_remark,w,h) {
	 		var id=this.genID();
	 		var html='';
       		switch (data_type) {
      	  	case this.ImageType:
      	  	html = '<p style="text-align: center;"><span class="div_data'
      	  	html = html + ' div_image" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">'
      	  	html = html + '<img src="' + data_value + '" alt="' + data_remark + '"';
      	  	if(!this.isEmpty(w))
      	       html=html+' width="'+w+'" height="'+ h+'"';
      	  	html=html+'/></span><br></p>';
      	  	  console.log(html);
      	  	break
      	  	case this.VoiceType:
		  	html = '<p><span contenteditable="false" class="div_data'
      	  	html = html + ' div_voice" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">'
      	  	html = html + data_remark + '``<embed id="' + id+ '" src="' + this.voiceImage[0] + '" alt="' + data_remark + '"/><span></p><br>'
	         	break
      	  	case this.VideoType:
		 	 html = '<p style="text-align: center;"><span contenteditable="false" class="div_data'
      	  	html = html + ' div_video" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">'
      	  	html = html + '<video width="100%" height="100%" id="' + this.genID() + '" src="' + data_value + '" controls="controls"></video></span></p><br>'
      	  	break
      	  	case this.AtType:
               	html = '<span class="div_data'
      	  	html = html + ' div_at" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">@'
      	  	html = html + data_remark + '</span>'
      	  	break
  			}
 			return html
	   	},
		parseShowDataHtml : function (data_type,data_value,data_remark) {
	 		var id=this.genID();
	 		var html='';
       		switch (data_type) {
      	  	case this.ImageType:
      	  	html = '<p style="text-align: center;"><span contenteditable="false" class="div_data'
      	  	html = html + ' div_image" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">'
      	  	html = html + '<img onclick="RE_clickImg(this)" id="' + this.genID() + '" src="' + data_value + '" alt="' + data_remark + '"/></span></p>'
      	  	break
      	  	case this.VoiceType:
		  	html = '<p><span contenteditable="false" class="div_data'
      	  	html = html + ' div_voice" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">'
      	  	html = html + data_remark + '``<embed id="' + id+ '" src="' + this.voiceImage[0] + '" alt="' + data_remark + '"/><span></span><br>'
	         	break
      	  	case this.VideoType:
		 	 html = '<p style="text-align: center;"><span class="div_data'
      	  	html = html + ' div_video" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">'
      	  	html = html + '<video onclick="RE_clickImg(this)" width="100%" height="100%" id="' + this.genID() + '" src="' + data_value + '" controls="controls"></video></span></p>'
      	  	break
      	  	case this.AtType:
               	html = '<span class="div_data'
      	  	html = html + ' div_at" data_type="' + data_type + '" data_value="' + data_value + '" data_remark="' + data_remark + '">@'
      	  	html = html + data_remark + '</span>'
      	  	break
  			}
 			return html
	   	},
		addPlaceholder:function(text){
			var editorframe = document.getElementById(this.id).getElementsByClassName('edui-editor-iframeholder')[0];
			//创建一个节点
			if(!this.placeholdeDiv)
			this.placeholdeDiv = document.createElement('div');
				//设置a的属性
				this.placeholdeDiv.className = 'editor_placeholder';
				this.placeholdeDiv.innerText = text;

  			//添加元素  将创建的节点添加到Id为d的div里
  			editorframe.insertBefore(this.placeholdeDiv,editorframe.firstChild);
		},
   	  	addPlayVoiceListener:function(){
   	  	    var voices=this.editor.document.getElementsByTagName('embed');
   	  	    var _this=this;
   	  	     console.log(voices);
   	  	    for (var voice of voices)
   	  	    {
   	  	    	     voice.addEventListener('click', function (e) {    //如果提供了事件对象，则这是一个非IE浏览器
   	  	    		_this.clickObject(this.parentNode);
   	  	    	});
   	  	    }
   	  	},
   	  	addImageClickListener:function(){
   	  			console.log("触发图片点击事件")
   	  	    var _this=this;
   	  	    var imgs=this.editor.document.getElementsByTagName('img');
   	  	    for (var img of imgs)
   	  	    {
   	  	    	     img.addEventListener('mouseleave', function (e) {    //如果提供了事件对象，则这是一个非IE浏览器
   	  	    	     	 console.log(2);
   	  	           	_this.IsmoveImage=false;
   	  	    		});
   	  	    	     img.addEventListener('mouseover', function (e) {    //如果提供了事件对象，则这是一个非IE浏览器
   	  	    		 console.log(1);
   	  	      	 _this.IsmoveImage=true;
   	  	    	     });
   	  	    }

   	  	    var ps=this.editor.document.getElementsByTagName('p');
   	  	    for (var p of ps)
   	  	    {
   	  	    	     p.addEventListener('click', function (e) {    //如果提供了事件对象，则这是一个非IE浏览器
   	  	    	       	  if(!_this.IsmoveImage)
    	  	    	      	  _this.stopBubbling(e);
   	  	    		});
   	  	    }
   	  	},
   	  	addShowClickListener:function(){
   	  	    var spans=	this.showEditor.getElementsByClassName('div_data')
   	  	    var _this=this;
   	  	    for (var span of spans)
   	  	    {
   	  	    	      span.addEventListener('click', function (e) {    //如果提供了事件对象，则这是一个非IE浏览器
   	  	    		_this.clickObject(this);

   	  	    	});
   	  	    }
   	  	},
   	  	clickObject:function(obj){
  	         var data_type = obj.getAttribute('data_type')
  	          if(this.isEmpty(data_type)) return;
  	 	  var value = obj.getAttribute('data_value')
  	 	   if(this.isEmpty(value)) return;
  		  var remark = obj.getAttribute('data_remark')
  		  var id
  		  var b = obj.getElementsByTagName("embed")[0];
  		  if(b)
               id = b.getAttribute('id')


  	        switch (data_type) {
   		 case this.ImageType:
   		    this.reOnclickImage(value)
   		    var url = encodeURIComponent(value.toString())
   		    if(this.IsCallBackUrl)
      	    window.location.href = "callback-onclick-image://" +url;
      	  break
    		  case this.VoiceType:
    		 console.log(this.isAutoPlayVoice);
               if (this.isAutoPlayVoice ===true) { this.playVoice(value, id) }

      	   this.reOnclickVoice(value)
      	   var url = encodeURIComponent(value.toString())
      	    if(this.IsCallBackUrl)
      	    window.location.href = "callback-onclick-voice://" + url;
      	   break
    		   case this.VideoType:
      	   this.reOnclickVideo(value)
      	   var url = encodeURIComponent(value.toString())
      	    if(this.IsCallBackUrl)
      	   window.location.href = "callback-onclick-video://" + url;
      	   break
    	          case this.AtType:
      	    this.reOnclickAt(remark, value)
      	    var url = encodeURIComponent(value.toString())+"&&&"+encodeURIComponent(remark.toString())
      	    window.location.href = "callback-onclick-at://" + url;
      	    break
  		  }
   	  	},
		playVoiceImg : function (id) {
  			var voiceImg;
  			if(this.isShowHtml)
  		       voiceImg=document.getElementById(id)
  		        else
  		        voiceImg=this.editor.document.getElementById(id)
  			var _this=this
  			if (_this.isEmpty(voiceImg)) return
   	   		this.voiceTimeout = setInterval(function () { _this.voiceImgTime(voiceImg) }, 300)
		},
		stopVoiceImg : function (id) {
  			clearInterval(this.voiceTimeout)
  			var voiceImg;
  			if(this.isShowHtml)
  		       voiceImg=document.getElementById(id)
  		        else
  		        voiceImg=this.editor.document.getElementById(id)
  			voiceImg.src = this.voiceImage[0]
		},
		voiceImgTime : function (obj) {
  		var currentSrc = obj.getAttribute('src')
  		var s = 0
  		for (var i = 0; i < this.voiceImage.length; i++) {
    		if (this.voiceImage[i] == currentSrc) {
      		s = i + 1
      		break
   		 }
  		}
  		if (s >= this.voiceImage.length) s = 0
  		obj.src = this.voiceImage[s]
		},
		playVoice:function(url, id) {
			 console.log(id);
 			 if(!this.isEmpty(this.audioId))
  			{
  			this.stopVoiceImg(this.audioId)
  			this.myAudio.pause()
 			 }
  			this.myAudio.preload = true
  			this.myAudio.controls = true
  			this.myAudio.src = url
  			this.myAudio.play()
  			this.audioId=id
  			this.playVoiceImg(id)
		},
   	  	setBold:function(){
   	  	     //加粗
   	  	     this.editor.execCommand('bold')
   	  	},
   	  	setItalic:function(){
   	  	     //斜体
   	  	     this.editor.execCommand('italic')
   	  	},
	    	setSubscript:function(){
	    		//下标
	    	      this.editor.execCommand('subscript')
	    	},
	    	setSuperscript:function(){
	    		//上标
	    	      this.editor.execCommand('superscript')
	    	},
	    	setStrikeThrough:function(){
	    		//删除线
	    	      this.editor.execCommand('strikeThrough')
	    	},
	    	setUnderline:function(){
	    		//下划线
	    	      this.editor.execCommand('underline')
	    	},
	      setBullets:function(){
	    		//有序列表
	    	      this.editor.execCommand('insertorderedlist')
	    	},
	    	setNumbers:function(){
	    		//无序列表
	    	      this.editor.execCommand('insertunorderedlist')
	    	},
	    	setJustifyLeft:function(){
	    		//居左
	    	      this.editor.execCommand('justify','left')
	    	},
	    	setJustifyRight:function(){
	    		//居右
	    	      this.editor.execCommand('justify','right')
	    	},
	    	setJustifyCenter:function(){
	    		//居中
	    	      this.editor.execCommand('justify','center')
	    	},
	  	setJustifyJustify:function(){
	    		//两端对齐
	    	      this.editor.execCommand('justify','justify')
	    	},
	      setBlockquote :function () {
	    		//设置引用
  			this.editor.execCommand( 'blockquote' );
		},
		setIndent : function () {
	    		//设置缩进
  			this.editor.execCommand( 'indent' );
		},
		setLineheight:function(value){
			//设置行距
  			this.editor.execCommand( 'lineheight' ,value);
		},
		setTopRowspacing:function(value){
			//设置行距
  			this.editor.execCommand( 'rowspacing' ,value,'top');
		},
        	setFontSize:function(fontsize){
        		//设置字体大小  px
        		this.editor.execCommand( 'fontsize', fontsize+'px');
        	},
        	setHorizontal:function(){
        		//插入分割线
        		this.editor.execCommand( 'horizontal');
        	},
        	setTextColor:function(color){
        		//设置字体颜色
        		this.editor.execCommand( 'forecolor', color );
        	},
        	setTextBackgroundColor:function(color){
        		//设置字体背景颜色
        		this.editor.execCommand( 'backcolor', color );
        	},
        	setRemoveformat:function(){
        		//	this.editor.execCommand( 'autotypeset');
        		this.editor.execCommand( 'removeformat', 'strong,em,sub,sup,span,underline,justify');

        		this.editor.execCommand( 'removeformat', 'span','text-decoration');
        		this.editor.execCommand( 'removeformat', 'span','color');
        		this.editor.execCommand( 'removeformat', 'span','background-color');
        		this.editor.execCommand( 'removeformat', 'p','text-align');
        		this.editor.execCommand( 'removeformat', 'p','text-indent');
        	//		this.editor.execCommand( 'removeformat', 'span','color');
        	},
		enabledEditingItems : function (e) {
  		var items = []
  		if (this.editor.queryCommandState('bold')) {
    		items.push('bold')
  		}
  		if (this.editor.queryCommandState('italic')) {
    		items.push('italic')
  		}
  		if (this.editor.queryCommandState('subscript')) {
    		items.push('subscript')
  		}
	      if (this.editor.queryCommandState('superscript')) {
  	      items.push('superscript')
  		}
  		if (this.editor.queryCommandState('strikeThrough')) {
    		items.push('strikeThrough')
  		}
  		if (this.editor.queryCommandState('underline')) {
   		 items.push('underline')
  		}
  		if (this.editor.queryCommandState('insertOrderedList')) {
   		 items.push('orderedList')
 		 }
 	       if (this.editor.queryCommandState('insertUnorderedList')) {
    		 items.push('unorderedList')
  		 }
  		 if (this.editor.queryCommandState('blockquote')) {
    		items.push('blockquote')
  		}
  		if (this.editor.queryCommandState('indent')) {
    		items.push('indent')
  		}
  		var justify=this.editor.queryCommandValue('justify');
  		if (justify==='center') {
    		items.push('justifyCenter')
  		}
  		if (justify==='justify') {
    		items.push('justifyFull')
  		}
  		if (justify==='left') {
    		items.push('justifyLeft')
  		}
  		if (justify==='right') {
    		items.push('justifyRight')
  		}
  		var lineheight=this.editor.queryCommandValue('lineheight');
  		if(!this.isEmpty(lineheight))
  		items.push('lineheight='+lineheight)
  		var fontsize=this.editor.queryCommandValue('fontsize');
  		if(!this.isEmpty(fontsize))
  		items.push('fontsize='+fontsize)
  		var link=this.editor.queryCommandValue('link');
  		if(!this.isEmpty(link))
  		items.push('link='+link)
  		if (document.queryCommandState('insertHorizontalRule')) {
    		items.push('horizontalRule')
  		}
  		this.reState(items.join(','))
		 //if(this.IsCallBackUrl)
 		 //window.location.href = "re-state://" + encodeURI(items.join(','));
  		//window.location.href = "re-state://" + encodeURI(items.join(','));
  		if(this.IsCallBackUrl)
  		{
 		 var url = encodeURIComponent(items.join(','))+'&&&'+encodeURIComponent(e.toString())
  		window.location.href = "re-state://" + url;
  		}
  		return items.join(',');
		},
   	  	genID : function () {
 		 return Number(Math.random().toString().substr(3, 6) + Date.now()).toString(36)
		},
   	  	isEmpty: function(a)
		{
			    if(typeof a == "undefined" || a == null || a == ""){
			        return true;
			    }
			    return false;
		},
		stopBubbling : function (e) {
  			e = window.event || e
  			if (e.stopPropagation) {
  			 e.stopPropagation() // 阻止事件 冒泡传播
 			 } else {
   			 e.cancelBubble = true // ie兼容
  			}
  		}
	}
	//RICHEDITOR结尾

	if (typeof exports == "object") {
		module.exports = RichEditor;
	} else if (typeof define == "function" && define.amd) {
		define([], function () {
			return RichEditor;
		})
	} else {
		window.RichEditor = RichEditor;
	}


})()
